hook.Add( 'Tick', 'ClearDecals', function()
	if GetConVarNumber( 'r_decals' ) <= 0 then
		RunConsoleCommand( 'r_cleardecals' )
	end
end )

local form1

concommand.Add( '+tweaker', function()
	form1 = vgui.Create( 'DFrame' )
		form1:SetPos( ScrW() / 2 - 160, ScrH() / 2 - 120 )
		form1:SetSize( 320, 240 )
		form1:SetDraggable( false )
		form1:SetVisible( true )
		form1:SetTitle( 'Tweaks Menu - NanoCat, 2012' )
		form1:ShowCloseButton( false )
		form1:MakePopup()
		form1.Paint = function()
			surface.SetDrawColor( 0, 0, 0, 150 )
			surface.DrawRect( 0, 0, form1:GetWide(), form1:GetTall() )

			surface.SetDrawColor( 0 ,0, 0, 255 )
			surface.DrawOutlinedRect( 0, 0, form1:GetWide(), form1:GetTall() )
			
			surface.SetDrawColor( 0, 0, 0, 255 )
			surface.DrawRect( 1, 1, form1:GetWide() - 2, 22 )
		end
	
	local tabs = vgui.Create( 'DPropertySheet', form1 )
		tabs:SetPos( 1, 22 )
		tabs:SetSize( 318, 217 )
		tabs.Paint = nil
		
	//Network settings
	local net = vgui.Create( 'DPanel' )
		net.Paint = nil
		
		local cmd = vgui.Create( 'DNumSlider', net )
			cmd:SetPos( 10, 5 )
			cmd:SetWide( 288 )
			cmd:SetText( 'Packets that could be sent to server per second.' )
			cmd:SetMin( 10 )
			cmd:SetMax( 100 )
			cmd:SetValue( GetConVarNumber( 'cl_cmdrate' ) )
			cmd:SetDecimals( 0 )
			cmd:SetConVar( 'cl_cmdrate' )
			
		local upd = vgui.Create( 'DNumSlider', net )
			upd:SetPos( 10, 45 )
			upd:SetWide( 288 )
			upd:SetText( 'Packets that your client receives from server.' )
			upd:SetMin( 10 )
			upd:SetMax( 100 )
			upd:SetValue( GetConVarNumber( 'cl_updaterate' ) )
			upd:SetDecimals( 0 )
			upd:SetConVar( 'cl_updaterate' )

		local rate = vgui.Create( 'DNumSlider', net )
			rate:SetPos( 10, 85 )
			rate:SetWide( 288 )
			rate:SetText( 'Bytes that host can receive from your client.' )
			rate:SetMin( 10000 )
			rate:SetMax( 100000 )
			rate:SetValue( GetConVarNumber( 'rate' ) )
			rate:SetDecimals( 0 )
			rate:SetConVar( 'rate' )

		local ping = vgui.Create( 'DLabel', net )
			ping:SetPos( 10, 165 )
			ping:SetWidth( 256 )
			ping:SetText( 'Your current ping is ' .. LocalPlayer():Ping() .. ' ms.' )
			
		local res = vgui.Create( 'DButton', net )
		local res_col = 175
			res:SetPos( 256, 140 )
			res:SetText( '' )
			res:SetSize( 48, 48 )
			res.Paint = function()
				surface.SetDrawColor( Color( res_col, res_col, res_col, 255 ) )
				surface.SetMaterial( Material( 'gui/html/refresh' ) )
				surface.DrawTexturedRect( 0, 0, res:GetWide(), res:GetTall() )
			end
			
			res.DoClick = function()
				res_col = 175
				
				RunConsoleCommand( 'cl_cmdrate', '30' )
				RunConsoleCommand( 'cl_updaterate', '20' )
				RunConsoleCommand( 'rate', '10000' )
				
				timer.Simple( 0.1, function() res_col = 255 end )
			end
			
			res.OnCursorEntered = function()
				res_col = 255
			end
			
			res.OnCursorExited = function()
				res_col = 175
			end
	
	//Render settings
	local rend = vgui.Create( 'DPanel' )
		rend.Paint = nil
		
		local dcls = vgui.Create( 'DNumSlider', rend )
			dcls:SetPos( 10, 5 )
			dcls:SetWide( 288 )
			dcls:SetText( 'Max renderable decals.' )
			dcls:SetMin( 0 )
			dcls:SetMax( 4096 )
			dcls:SetValue( GetConVarNumber( 'r_decals' ) )
			dcls:SetDecimals( 0 )
			dcls:SetConVar( 'r_decals' )
			
		local upd = vgui.Create( 'DNumSlider', rend )
			upd:SetPos( 10, 45 )
			upd:SetWide( 288 )
			upd:SetText( 'Model LOD.' )
			upd:SetMin( -1 )
			upd:SetMax( 5 )
			upd:SetValue( GetConVarNumber( 'r_lod' ) )
			upd:SetDecimals( 0 )
			upd:SetConVar( 'r_lod' )
			
		local shd = vgui.Create( 'DCheckBoxLabel', rend )
			shd:SetPos( 10,95 )
			shd:SetText( 'Draw own shadow' )
			shd:SetConVar( 'cl_drawownshadow' )
			shd:SetValue( GetConVarNumber( 'cl_drawownshadow' ) )
			shd:SizeToContents()
			
		local shd = vgui.Create( 'DCheckBoxLabel', rend )
			shd:SetPos( 10,115 )
			shd:SetText( 'Render shadows' )
			shd:SetConVar( 'r_shadows' )
			shd:SetValue( GetConVarNumber( 'r_shadows' ) )
			shd:SizeToContents()

		local fps = vgui.Create( 'DLabel', rend )
			fps:SetPos( 10, 165 )
			fps:SetWidth( 256 )
			fps:SetText( 'Your current FPS rate is ' .. math.min( 1/FrameTime() ) .. ' fps.' )
			
		local rres = vgui.Create( 'DButton', rend )
		local rres_col = 175
			rres:SetPos( 258, 140 )
			rres:SetText( '' )
			rres:SetSize( 48, 48 )
			rres.Paint = function()
				surface.SetDrawColor( Color( rres_col, rres_col, rres_col, 255 ) )
				surface.SetMaterial( Material( 'gui/html/refresh' ) )
				surface.DrawTexturedRect( 0, 0, rres:GetWide(), rres:GetTall() )
			end
			
			rres.DoClick = function()
				rres_col = 175
				
				RunConsoleCommand( 'r_decals', '2048' )
				RunConsoleCommand( 'r_lod', '-1' )
				RunConsoleCommand( 'cl_drawownshadow', '0' )
				RunConsoleCommand( 'r_shadows', '1' )
				RunConsoleCommand( 'r_fullrender', '0' )
				
				timer.Simple( 0.1, function() rres_col = 255 end )
			end
			
			rres.OnCursorEntered = function()
				rres_col = 255
			end
			
			rres.OnCursorExited = function()
				rres_col = 175
			end
			
		local nodec = vgui.Create( 'DButton', rend )
		local nodec_col = 175
			nodec:SetPos( 208, 140 )
			nodec:SetText( '' )
			nodec:SetSize( 48, 48 )
			nodec.Paint = function()
				surface.SetDrawColor( Color( nodec_col, nodec_col, nodec_col, 255 ) )
				surface.SetMaterial( Material( 'gui/html/stop' ) )
				surface.DrawTexturedRect( 0, 0, nodec:GetWide(), nodec:GetTall() )
			end
			
			nodec.DoClick = function()
				nodec_col = 175
				
				RunConsoleCommand( 'r_cleardecals' )
				
				timer.Simple( 0.1, function() nodec_col = 255 end )
			end
			
			nodec.OnCursorEntered = function()
				nodec_col = 255
			end
			
			nodec.OnCursorExited = function()
				nodec_col = 175
			end
	
	hook.Add( 'Tick', 'PerfRatesUpdate', function()
		ping:SetText( 'Your current ping is ' .. LocalPlayer():Ping() .. ' ms.' )
		fps:SetText( 'Your current FPS rate is ' .. math.floor( 1/FrameTime() ) .. ' fps.' )
	end )
	
	tabs:AddSheet( 'Network', net, 'gui/silkicons/world', false, false, 'Network perfomance configuration' )
	tabs:AddSheet( 'Render', rend, 'gui/silkicons/application', false, false, 'Render perfomance configuration' )
	tabs:AddSheet( 'About', about, 'gui/silkicons/page', false, false, 'About this addon' )
	tabs.Paint = nil
end )

concommand.Add( '-tweaker', function()
	hook.Remove( 'Tick', 'PerfRatesUpdate' )
	form1:Remove()
end )